package fr.univlyon1.tiw1.inscriptions.modele;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

/**
 * Created by ecoquery on 19/10/2016.
 */
@Entity
@XmlType(propOrder = {"email", "name", "company"})
public class Person {
    @Id
    private String email;
    private String name;
    private String company;
    @ManyToMany
    @JoinTable(name = "inscriptions",
            joinColumns = {@JoinColumn(name = "person_email")},
            inverseJoinColumns = {@JoinColumn(name = "event_id")})
    private Collection<Event> inscriptions = new ArrayList<>();

    @XmlElement(required = true)
    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCompany() {
        return company;
    }

    public void setCompany(String company) {
        this.company = company;
    }

    @XmlTransient
    public Collection<Event> getInscriptions() {
        return Collections.unmodifiableCollection(inscriptions);
    }

    public void setInscriptions(Collection<Event> inscriptions) {
        this.inscriptions = inscriptions;
    }

    protected void addEvent(Event event) {
        inscriptions.add(event);
    }

    public void inscrire(Event event) {
        addEvent(event);
        event.addPerson(this);
    }
}
